#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <utility>
#include <stack>
#include <queue>
#include <stdint.h>
#include <stdlib.h>
using namespace std;

#define NAME "candies"

#define MP(x, y) make_pair((x), (y))
#define X first
#define Y second

const int nmax = 1000100;

int arr[nmax], n;
int lmax = 0;

int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &arr[i]);
    }
    int type1 = arr[0], type2;
    int l = 0, r = 0;
    while (1) {
        r = l;
        type1 = arr[r];
        while (r < n && arr[r] == type1)
            ++r;
        if (r >= n)
            break;
        type2 = arr[r];
        while (r < n && (arr[r] == type1 || arr[r] == type2))
            ++r;
        --r;

        if (r >= n)
            break;
        if (r-l+1 > lmax)
            lmax = r-l+1;

        l = r;
        type2 = arr[l];
        while (arr[l] == type2)
            --l;
        ++l;
    }

    printf("%d\n", lmax);
    return 0;
}
