#include <iostream>
#include <fstream>

using namespace std;

typedef long long ll;

const int MAX=2e3+2;

int n, m, k;
ll arr[MAX][MAX], lft[MAX][MAX], up[MAX][MAX], down[MAX][MAX], rght[MAX][MAX], head[MAX][MAX];
ll c[256], ans=-1e18;

int main()
{
    ifstream cin("submarine.in");
    ofstream cout("submarine.out");
    ios::sync_with_stdio(0);
    cin >> k;
    for(int i=0; i<k; ++i)
        cin >> c['a'+i];
    cin >> n >> m;
    for(int i=1; i<=n; ++i)
        for(int j=1; j<=m; ++j)
        {
            char in;
            cin >> in;
            arr[i][j]=c[in];
        }
    for(int i=1; i<=n; ++i)
        for(int j=1; j<=m; ++j)
        {
            lft[i][j]=max(0LL, lft[i][j-1]+arr[i][j]);
            up[i][j]=max(0LL, up[i-1][j]+arr[i][j]);
        }
    for(int i=n; i>=1; --i)
        for(int j=m; j>=1; --j)
        {
            down[i][j]=max(0LL, down[i+1][j]+arr[i][j]);
            rght[i][j]=max(0LL, rght[i][j+1]+arr[i][j]);
        }
    for(int i=1; i<=n; ++i)
        for(int j=1; j<=m; ++j)
            head[i][j]=max(head[i][j-1], lft[i][j-1]+up[i-1][j])+arr[i][j];
    for(int i=1; i<=n; ++i)
        for(int j=2; j<=m; ++j)
            ans=max(ans, arr[i][j]+head[i][j-1]+up[i-1][j]+down[i+1][j]+rght[i][j+1]);
    cout << ans << endl;
    return 0;
}
